SystemOrganization addCategory: #SeasideAssistants!
SystemOrganization addCategory: #'SeasideAssistants-Tests'!
SystemOrganization addCategory: #'SeasideAssistants-Core'!
SystemOrganization addCategory: #'SeasideAssistants-Platform'!

!WAAbstractHtmlBuilder methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 10:23'!
openTag: aString
	self document openTag: aString attributes: self attributes renderer: self.
	attributeBuffer _ nil.
! !

WAComponent subclass: #WADuplicateIdTest
	instanceVariableNames: 'shouldRaiseDuplicateCssIdErrors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WADuplicateIdTest methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:59'!
renderContentOn: html

	self renderDuplicateIdErrorOptionOn: html.	
	html break; break.
	html attributes style: 'background: blue; color: yellow'.
	html spanNamed: 'abcdef' with: 'This is a span with id="abcdef"'.
	html break; break.
	html attributes style: 'border: 1px red solid; width: 25%; background: lightgreen; color: blue'.
	html divNamed: 'abcdef' with: 
			[html 
				text: 'This is a div';
				break;
				text: 'with id="abcdef"']
			
! !

!WADuplicateIdTest methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:44'!
renderDuplicateIdErrorOptionOn: html
	html renderer shouldRaiseDuplicateCssIdErrors: shouldRaiseDuplicateCssIdErrors.
	html renderer shouldRaiseDuplicateCssIdErrors
		ifTrue:
			[html text: 'Duplicate id detection currently enabled :'.
			html space.
			html anchorWithAction: [shouldRaiseDuplicateCssIdErrors := false] text: 'disable it']
		ifFalse:
			[html text: 'Duplicate id detection currently disabled :'.
			html space.
			html anchorWithAction: [shouldRaiseDuplicateCssIdErrors := true] text: 'enable it'].
! !

!WADuplicateIdTest methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:44'!
rendererClass
	^ WADuplicateIdTestRenderer! !

WAComponent subclass: #WANestedTagCanvasTest
	instanceVariableNames: 'isNested shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms name nickName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:12'!
initialize
	isNested := false.
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:12'!
renderContentOn: html 
	isNested 
		ifTrue: 
			[(html anchor)
				callback: [isNested := false];
				text: 'Suppress <form> nesting'.
			html
				space;
				space;
				bold: 'Note:';
				space;
				text: 'by default, nested <form> are silently discarded']
		ifFalse: 
			[(html anchor)
				callback: [isNested := true];
				text: 'Add <form> nesting'].
	(html form)
		defaultAction: [self inform: 'You do not like to click with a mouse, do you ?'];
		with: 
				[(html div)
					attributeAt: 'style' put: 'border: green solid 1px; width: 50%; padding: 5px';
					with: 
							[html text: 'Enter your name'.
							html space.
							html textInput value: name; callback: [:v | name := v].
							html break.
							isNested 
								ifTrue: [html form with: [self renderMoreContentOn: html]]
								ifFalse: [self renderMoreContentOn: html].
							(html submitButton)
								callback: [self inform: 'Hello ' , name];
								text: 'Say hello']]
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:13'!
rendererClass
	^ WARenderCanvas
! !

!WANestedTagCanvasTest methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:13'!
renderMoreContentOn: html 
	| div |
	div := html div.
	isNested 
		ifTrue: [div attributeAt: 'style' put: 'border: red solid 1px; width: 70%; margin: 10px; padding: 5px;'].
	div with:
			[html text: 'Enter your nickname'.
			html space.
			html textInput value: nickName; callback: [:v | nickName := v].
			html break.
			html submitButton callback: [self inform: 'Good bye ' , nickName];
				text: 'Say good bye'].
! !

WAComponent subclass: #WANestedTagTest
	instanceVariableNames: 'isNested shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms name nickName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WANestedTagTest methodsFor: 'initialization' stamp: 'mb 11/4/2005 10:27'!
initialize
	isNested := false.
	nickName := String new.
	name := String new.
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 11/4/2005 10:43'!
renderContentOn: html
	isNested 
		ifTrue: 
			[html anchorWithAction: [isNested := false] text: 'Suppress <form> nesting'.
			html
				space;
				space;
				bold: 'Note:';
				space;
				text: 'By default, nested <form> are silently discarded'.
			html break.
			self renderNestedFormErrorOptionOn: html.	
			html break.
			self renderNestedFormDiscardOptionOn: html]
		ifFalse: 
			[html anchorWithAction: [isNested := true] text: 'Add <form> nesting'].
	html break.
	html form: 
			[html attributes style: 'border: green solid 1px; width: 50%; padding: 5px'.
			html div: 
					[html text: 'Enter your name'.
					html space.
					html textInputWithValue: name callback: [:v | name := v].
					html break.
					isNested 
						ifTrue: [html form: [self renderMoreContentOn: html]]
						ifFalse: [self renderMoreContentOn: html].
					html submitButtonWithAction: [self inform: 'Hello ' , name]
						text: 'Say hello']]! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 11/4/2005 10:01'!
rendererClass
	^WANestedTagTestRenderer! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 11/4/2005 10:30'!
renderMoreContentOn: html 
	isNested 
		ifTrue: [html attributes style: 'border: red solid 1px; width: 70%; margin: 10px; padding: 5px;'].
	html div: 
			[html text: 'Enter your nickname'.
			html space.
			html textInputWithValue: nickName callback: [:v | nickName := v].
			html break.
			html submitButtonWithAction: [self inform: 'Good bye ' , nickName]
				text: 'Say good bye']! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 11/4/2005 10:28'!
renderNestedFormDiscardOptionOn: html
	html renderer shouldSilentlyDiscardNestedForms: shouldSilentlyDiscardNestedForms.
	html renderer shouldSilentlyDiscardNestedForms
		ifTrue:
			[html text: 'Silent discard of nested <form> currently enabled :'.
			html space.
			html anchorWithAction: [shouldSilentlyDiscardNestedForms := false] text: 'disable it']
		ifFalse:
			[html text: 'Silent discard of nested <form> currently disabled :'.
			html space.
			html anchorWithAction: [shouldSilentlyDiscardNestedForms := true] text: 'enable it'].
! !

!WANestedTagTest methodsFor: 'rendering' stamp: 'mb 11/4/2005 10:28'!
renderNestedFormErrorOptionOn: html
	html renderer shouldRaiseNestedFormErrors: shouldRaiseNestedFormErrors.
	html renderer shouldRaiseNestedFormErrors
		ifTrue:
			[html text: 'Nested <form> detection currently enabled :'.
			html space.
			html anchorWithAction: [shouldRaiseNestedFormErrors := false] text: 'disable it']
		ifFalse:
			[html text: 'Nested <form> detection currently disabled :'.
			html space.
			html anchorWithAction: [shouldRaiseNestedFormErrors := true] text: 'enable it'].
! !

!WARenderCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:20'!
shouldRaiseNestedFormErrors
	"Answer true to raise an error in case of nested form tags
	Can be subclassed"
	^false
! !

!WARenderCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:20'!
shouldSilentlyDiscardNestedForms
	"Answer true to ignore nested form tags
	Can be subclassed"
	^true
! !

WAHtmlRenderer subclass: #WADuplicateIdTestRenderer
	instanceVariableNames: 'shouldRaiseDuplicateCssIdErrors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WADuplicateIdTestRenderer methodsFor: 'initialize-release' stamp: 'mb 1/26/2006 11:36'!
initialize
	super initialize.
	shouldRaiseDuplicateCssIdErrors := super shouldRaiseDuplicateCssIdErrors.
! !

!WADuplicateIdTestRenderer methodsFor: 'accessing' stamp: 'mb 1/26/2006 11:36'!
shouldRaiseDuplicateCssIdErrors
	^shouldRaiseDuplicateCssIdErrors ifNil: [super shouldRaiseDuplicateCssIdErrors]! !

!WADuplicateIdTestRenderer methodsFor: 'accessing' stamp: 'mb 1/26/2006 11:37'!
shouldRaiseDuplicateCssIdErrors: anObject
	shouldRaiseDuplicateCssIdErrors _ anObject! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:54'!
form: aBlock 
	((self document isWithinTag: 'form') not or: 
			[self shouldRaiseNestedFormErrors not 
				and: [self shouldSilentlyDiscardNestedForms not]]) 
		ifTrue: 
			[self 
				formWithMethod: 'post'
				action: context actionUrl urlString
				do: 
					[self div: 
							[context actionUrl parameters keysAndValuesDo: 
									[:k :v | 
									self 
										inputWithType: 'hidden'
										named: k
										value: v].
							aBlock value]]]
		ifFalse: 
			[self shouldRaiseNestedFormErrors 
				ifTrue: [self error: 'Nested <form> !!']
				ifFalse: [aBlock value]]
! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:56'!
shouldRaiseDuplicateCssIdErrors
	"Answer true to raise an error in case of duplicate CSS id in page
	Can be subclassed"
	^false
! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:48'!
shouldRaiseNestedFormErrors
	"Answer true to raise an error in case of nested form tags
	Can be subclassed"
	^false
! !

!WAHtmlRenderer methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:57'!
shouldSilentlyDiscardNestedForms
	"Answer true to ignore nested form tags
	Can be subclassed"
	^true
! !

WAHtmlRenderer subclass: #WANestedTagTestRenderer
	instanceVariableNames: 'shouldRaiseNestedFormErrors shouldSilentlyDiscardNestedForms'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WANestedTagTestRenderer methodsFor: 'initialize-release' stamp: 'mb 11/4/2005 10:01'!
initialize
	super initialize.
	shouldRaiseNestedFormErrors := super shouldRaiseNestedFormErrors.
	shouldSilentlyDiscardNestedForms := super shouldSilentlyDiscardNestedForms.! !

!WANestedTagTestRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 10:07'!
shouldRaiseNestedFormErrors
	^shouldRaiseNestedFormErrors ifNil: [super shouldRaiseNestedFormErrors]! !

!WANestedTagTestRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 09:58'!
shouldRaiseNestedFormErrors: anObject
	"Set the value of shouldRaiseNestedFormErrors"

	shouldRaiseNestedFormErrors _ anObject! !

!WANestedTagTestRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 10:06'!
shouldSilentlyDiscardNestedForms
	^shouldSilentlyDiscardNestedForms ifNil: [super shouldSilentlyDiscardNestedForms]
! !

!WANestedTagTestRenderer methodsFor: 'accessing' stamp: 'mb 11/4/2005 09:58'!
shouldSilentlyDiscardNestedForms: anObject
	"Set the value of shouldSilentlyDiscardNestedForms"

	shouldSilentlyDiscardNestedForms _ anObject! !

WAFrameComponent subclass: #WAMoreTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Tests'!

!WAMoreTests methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:40'!
initialize
	self contents:
	 (WASimpleNavigation new
		add: WAImageTest new label: 'Images';
		add: WAHomeTest new label: 'Home';
		add: WACacheTest new label: 'Cache';
		add: WADefaultFormTest new label: 'Default Form';
		add: WALinkSubmitTest new label: 'Submit';
		add: WANestedTagTest new label: 'Nested forms';
		add: WANestedTagCanvasTest new label: 'Nested forms (canvas)';
		add: WADuplicateIdTest new label: 'Duplicate id=';
		yourself)


! !

!WAMoreTests methodsFor: 'as yet unclassified' stamp: 'mb 11/27/2005 19:11'!
renderContentOn: html
	html heading: 'He !! Another row of tests !!' level: 2.
	html render: contents.
! !

!WAAllTests methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 10:26'!
initialize
	self contents:
	 (WASimpleNavigation new
		add: WAInputTest new label: 'Input';
		add: WAHtmlTest new label: 'Html';
		add: WAEncodingTest new label: 'Encoding';
		add: WAErrorTest new label: 'Error';
		add: WAExceptionTest new label: 'Exception';
		add: WAClosureTest new label: 'Closure';
		add: WATransactionTest new label: 'Transaction';
		add: WAUploadTest new label: 'Upload';
		add: (WAParentTest new parent: self) label: 'Parent';
		add:  WAPathTest new label: 'Path';
		add: WATaskTest new label: 'Task';
		add: WACookieTest new label: 'Cookies';
		add: WACallbackTest new label: 'Callbacks';
		add: WACanvasTest new label: 'Canvas';
		add: WAMoreTests new label: 'More...';
		yourself)
! !

!WAHtmlStreamDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 18:59'!
closeTag: aString
	self writeCloseTag: aString on: self bodyStream.
	self popTag			
! !

!WAHtmlStreamDocument methodsFor: '*SeasideAssistants' stamp: 'mb 1/26/2006 11:25'!
openTag: aString attributes: anAttributes
	super openTag: aString attributes: anAttributes! !

!WAHtmlStreamDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:00'!
openTag: aString attributes: anAttributes renderer: aRenderer
	self checkCssIds: anAttributes renderer: aRenderer. "May raise an error"
	self writeOpenTag: aString attributes: anAttributes on: self bodyStream.
	self pushTag: aString.
! !

!WAPrettyPrintedDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:18'!
closeTag: aString
	indentLevel _ indentLevel - 1.
	indentCloseTags removeLast ifTrue:
		[html break.
		indentLevel timesRepeat: [html space]].

	(self shouldPrintCloseTagFor: aString) ifTrue:
		[html text: '</'.
		html spanClass: (self cssClassFor: aString) with: [html text: aString].
		html text: '>'].
	self popTag
! !

!WAPrettyPrintedDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:19'!
initializeWithRenderer: aRenderer
	html _ aRenderer.
	indentCloseTags _ OrderedCollection with: false.
	indentLevel _ 0.
	self clearTagStack.
	! !

!WAPrettyPrintedDocument methodsFor: '*SeasideAssistants' stamp: 'mb 1/26/2006 11:26'!
openTag: aString attributes: anAttributes
	super openTag: aString attributes: anAttributes! !

!WAPrettyPrintedDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:19'!
openTag: aString attributes: anAttributes renderer: aRenderer
	html break.
	indentLevel timesRepeat: [html space].
	
	html text: '<'.
	html spanClass: (self cssClassFor: aString) with: [html text: aString].
	
	self attributes: anAttributes.
	
	(self shouldPrintCloseTagFor: aString)
		ifFalse: [html space; text: '/'].
	html text: '>'.
	
	indentLevel _ indentLevel + 1.
	indentCloseTags removeLast; addLast: true; addLast: false.
	self pushTag: aString.	
! !

!WAScriptTag methodsFor: '*SeasideAssistants' stamp: 'mb 1/5/2006 14:05'!
with: aBlock
	isClosed := true.
	self attributes at: 'type' ifAbsentPut: ['text/javascript'].
	self document openTag: self tag attributes: attributes renderer: self.
	canvas html: aBlock.
	self document closeTag: self tag.
! !

!WAStyleCollector methodsFor: '*SeasideAssistants' stamp: 'avi 7/2/2004 11:03'!
closeTag: aString! !

!WAStyleCollector methodsFor: '*SeasideAssistants' stamp: 'mb 1/26/2006 11:26'!
openTag: aString attributes: anAttributes
	super openTag: aString attributes: anAttributes! !

!WAStyleCollector methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:33'!
openTag: aString attributes: anAttributes renderer: aRenderer
	anAttributes ifNil: [^ self].
	anAttributes associations do:
		[:assoc |
		assoc key = 'class' ifTrue:
			[self styles addAll: ((assoc value findTokens: ' ') collect: [:ea | '.', ea])].
		assoc key = 'id' ifTrue: [self styles add: '#', assoc value]].
	self pushTag: aString.
! !

WAHtmlDocument subclass: #WASmartHtmlDocument
	instanceVariableNames: 'tagStack cssIds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Core'!

!WASmartHtmlDocument class methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 16:52'!
initialize
	self reshapeClassHierarchy.! !

!WASmartHtmlDocument class methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 16:52'!
reshapeClassHierarchy
	| classBuilder |
	classBuilder _ ClassBuilder new.
	(self superclass subclasses asOrderedCollection
		remove: self;
		yourself)
	do:
		[:ea | | newClass |
		newClass := classBuilder reshapeClass: ea toSuper: self.         
		classBuilder mutate: ea to: newClass].
	
	self inform: 'Warning: WAHtmlDocument class hierarchy was reshaped'! !

!WASmartHtmlDocument methodsFor: 'duplicate css id' stamp: 'mb 1/26/2006 11:31'!
checkCssIds: attributes renderer: aRenderer
	| id |
	attributes isNil ifTrue: [^self].
	id := (attributes at: 'id' ifAbsent: [^self]) value asSymbol.
	cssIds isNil ifTrue: [cssIds := Set new].
	
	((cssIds includes: id) 
		and: [aRenderer shouldRaiseDuplicateCssIdErrors])
			ifTrue:
				[self error: 'Duplicate id in HTML document']
			ifFalse:
				[cssIds add: id].
! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:40'!
clearTagStack
	tagStack := OrderedCollection new.! !

!WASmartHtmlDocument methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 12:28'!
initializeWithRoot: aRoot
	super initializeWithRoot: aRoot.
	self clearTagStack.	
	! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:41'!
isWithinTag: aString
	^ tagStack includes: aString! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 1/26/2006 11:25'!
openTag: aString attributes: anAttributes
	self openTag: aString attributes: anAttributes renderer: nil! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:42'!
openTag: aString attributes: anAttributes renderer: aRenderer
	self subclassResponsibility
! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 11/27/2005 18:45'!
popTag
	^ tagStack removeLast
! !

!WASmartHtmlDocument methodsFor: 'nested forms' stamp: 'mb 1/26/2006 13:40'!
pushTag: aString
	tagStack add: aString
! !

!WAHtmlCanvas methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 17:31'!
tag: aString
	aString = 'form' ifTrue: [^self form].
	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlTreeDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:02'!
closeTag: aString
	self popElement name = aString ifFalse: [self error: 'Mismatched tags'].
	self popTag		
! !

!WAHtmlTreeDocument methodsFor: '*SeasideAssistants' stamp: 'mb 1/26/2006 11:25'!
openTag: aString attributes: anAttributes
	super openTag: aString attributes: anAttributes! !

!WAHtmlTreeDocument methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:04'!
openTag: aString attributes: anAttributes renderer: aRenderer
	| element |
	self checkCssIds: anAttributes renderer: aRenderer. "May raise an error"
	element _ WAHtmlElement named: aString attributes: anAttributes.
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [element beClosed]
		ifFalse: [element notClosed].
	self pushElement: element.
	self pushTag: aString.
! !

!WAFormTag methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 17:23'!
isWithinForm

	^ self document isWithinTag: self tag! !

!WAFormTag methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 17:24'!
with: aBlock 
	(self isWithinForm not or: 
			[canvas shouldRaiseNestedFormErrors not 
				and: [canvas shouldSilentlyDiscardNestedForms not]]) 
		ifTrue: [super with: aBlock]
		ifFalse: 
			[canvas shouldRaiseNestedFormErrors 
				ifTrue: [self error: 'Nested <form> !!']
				ifFalse: 
					[canvas nest: aBlock.
					isClosed := true]]! !

PackageInfo subclass: #SeasideAssistantsVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAssistants-Platform'!

!SeasideAssistantsVWInfo class methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:08'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideAssistantsVW5.st')! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:12'!
externalName
	^ 'SeasideAssistants'! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:10'!
ignoredCategories
	^ #('Platform')! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:14'!
includesSystemCategory: aString
	^ (aString beginsWith: 'SeasideAssistants-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:14'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seasideassistants')
		and: [(aString endsWith: 'squeak') not]! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:17'!
namespace
	^'Seaside'! !

!SeasideAssistantsVWInfo methodsFor: 'as yet unclassified' stamp: 'mb 1/26/2006 11:10'!
needsNamespace
	^false! !

!WATagBrush methodsFor: '*SeasideAssistants' stamp: 'mb 11/27/2005 19:34'!
with: aBlock
	self document openTag: self tag attributes: attributes renderer: canvas.
	super with: [self within: aBlock].
	self document closeTag: self tag.! !
WASmartHtmlDocument initialize!
